//Tasten
int tastenH = 50;
int anzahlT;
boolean[] tasteAktiv;
boolean tastenWechsel=true;
char[] tBeschriftung;
PFont font;

//Parameter
double a,b,c,d;
//Bildausschnitt zu Beginn:
float wh = 6.0;
float xU = -3.0; 
float yU = -3.0; 
float xO,yO;
float xK,yK;
float xHK,yHK;
float x,y;
int hgf = 0;//Hintergrund schwarz
boolean start=true;
boolean sP=false;//soll beim Mausklick gezoomt oder der Startpunkt eingetragen werden
color farbe;
//Für starkes Zoomen müssen sehr viele Iterationen durchgeführt werden.
//Damit die Fehler dabei nicht zu groß werden, sollte man mit double-Werten rechnen
double xStart = 0;
double yStart = 0;
int nPoints = 20000; // Punkte pro Orbit

// Hilfsvariablen
double xH = xStart;
double yH = yStart; 

///////////////////////////////////////////////////////////////////////////
//Initialisierungen  
///////////////////////////////////////////////////////////////////////////
void setup() { 
  size(800, 800);
  background(hgf);
  tastenEinstellungen();
  colorMode(HSB,256,256,256);
  stroke(0,255,255);
  strokeWeight(5);
  point(width/2.0,height/2.0);//Ursprung
  xO=xU+wh; yO=yU+wh;
  a = random(-2.5,2.5); b = random(-2.5,2.5); c = random(-2.5,2.5); d = random(-2.5,2.5); 
  //Interessante Parameter: 
  //a = 1.8227794170379639 ;b = 1.2036352157592773 ;c = 1.2581422328948975 ;d = 1.29048752784729;
  //a = -0.5073082447052002 ;b = 2.0004982948303223 ;c = 1.904932975769043 ;d = 0.7140970230102539;
  //a=-1.4; b=1.6;c=1.0;d=0.7;
  //a = 1.8129115104675293 ;b = -1.908460259437561 ;c = 2.1464738845825195 ;d = 1.593207836151123;
  //a = 1.648834228515625 ;b = 2.1489949226379395 ;c = -0.6424182653427124 ;d = 1.7533493041992188;
  //a = 0.8464165;  b = -1.177206;  c = -1.9538873;  d = -0.5927634;
   // a = -1.7020127773284912 ;b = 1.5269484519958496 ;c = 2.276003837585449 ;d = 1.8719968795776367;
   a = -0.7693741321563721 ;b = 1.8630619049072266 ;c = 1.38907790184021 ;d = 1.5833079814910889;


   println("a = "+a, ";b = "+b, ";c = "+c, ";d = "+d+";");
  println(xU,xO,yU,yO); 
}
///////////////////////////////////////////////////////////////////////////
void draw() {
  tastenZeichnen();
  if(start){    
    if(!sP) background(hgf);
    iteriere(xH,yH); 
  
  
    start = false;
  }
}
///////////////////////////////////////////////
void tastenEinstellungen(){
   rectMode(CENTER);
   font = createFont("Arial",20);
   textSize(24);  
   String s = "nhpzs";
   anzahlT = s.length();
   tasteAktiv = new boolean[anzahlT];
   tBeschriftung = new char[anzahlT];
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false; 
   for(int i= 0; i<anzahlT; i++) tBeschriftung[i] = s.charAt(i);
   for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
}
//////////////////////////////////////

void keyPressed() {  //für Tastaturbedienung
  if (key == 'n') {
     nPoints = 2*nPoints;
     start = true;
  }  
  if (key == 'h'){
    if(hgf==0) hgf=255;
    else hgf = 0;
    background(hgf);
    start = true;
  }
  if(key == 'p'){
    sP = !sP;
  }
  if(key == 'z'){
    sP=false;
    a = random(-2,2); b = random(-2,2); c = random(-2,2); d = random(-2,2); 
    println("a = "+a, ";b = "+b, ";c = "+c, ";d = "+d+";");
    start = true;
  }
  if (key == 's') save("CA1.jpg");
} 
/////////////////////////////////////////////////////
//Die Stelle, auf die man klickt wird vergrößert bzw der neue Startpunkt eingetragen
//////////////////////////////////////////////////////

void mousePressed() {  
   if(mouseY < height-tastenH){
    x = xU + wh*mouseX/width;
    y = yU + wh*(height-mouseY)/height;  
    if (!sP){
      background(hgf);
      wh*=0.66;
      xU = x-wh/2.0;xO = xU+wh;
      yU = y-wh/2.0;yO = yU+wh;
      println(x,y,xU,yU,xO,yO);
    }
    if( sP){
      strokeWeight(10);
      farbe = color(random(255),255,255);
      stroke(farbe);
      point(mouseX,mouseY);
      xH = x;
      yH = y;
      println("Neuer Startpunkt: "+xH,yH);
      iteriere(xH,yH); 
    }
    start = true;
   }else{
      int ort = int(mouseX/(tastenH));
       if(tastenWechsel){
          for(int i=0; i <anzahlT;i++) tasteAktiv[i]=false;
          tastenWechsel = false;
       }
      switch(ort){
        
      case 0://'n'   
         tasteAktiv[0]=true;
         nPoints = 2*nPoints;
         start = true;
      break;
      
      case 1: //'h'   
       tasteAktiv[1]=true;
       if(hgf==0) hgf=255;
        else hgf = 0;
       background(hgf);
       start = true;
      break;
      
      case 2://'p'
       tasteAktiv[2]=true;
       sP = !sP;
      break;
      
      case 3: //'z'   
       tasteAktiv[3]=true;
       sP=false;
       a = random(-2,2); b = random(-2,2); c = random(-2,2); d = random(-2,2); 
       println("a = "+a, ";b = "+b, ";c = "+c, ";d = "+d+";");
       start = true;
      break;
      
      case 4://'s'   Online Version ohne save
       tasteAktiv[4]=true;
       a=-1.4; b=1.6;c=1.0;d=0.7;
       println(xU,xO,yU,yO);
       nPoints = 20000;
       sP=false;
       wh = 6.0;
       xU = -3.0; xO = xU+wh;
       yU = -3.0; yO = yU+wh;
       start = true;       
      break;
      
      default:      
        println("Keine Aktion");
      break;
  }
 }
}
//////////////////////////////////////////////////////////
void iteriere(double xAlt,double yAlt) {  
  if(!sP){
      farbe = color(random(255),255,255);
      stroke(farbe); 
  }
  int i=0;
  strokeWeight(1);
  
  while (i <=nPoints) {
    if (Math.abs(xAlt)< 5 && Math.abs(yAlt)< 5) {
      double xNeu = Math.sin(a*yAlt) - Math.cos(b*xAlt);
      double yNeu = Math.sin(c*xAlt) - Math.cos(d*yAlt);
      float xK = round(map((float)xNeu, xU, xO, 0, width));                 
      float yK = round(map((float)yNeu, yU, yO, 0, height));    
      point(xK, height-yK);  
      xAlt = xNeu;
      yAlt = yNeu;
    }
    i++;
  }
  println(nPoints+" Punkte eingetragen");
}
////////////////////////////////////////////////////////
void tastenZeichnen(){
  tastenWechsel=true;
  fill(160,180,180);
  rect(width/2,height-tastenH/2,width,tastenH);
  for(int i=0; i<anzahlT; i++){
      if(tasteAktiv[i])fill(color(40,255,255));
      else fill(color(255));     
      rect(tastenH/2 + i*tastenH,height-tastenH/2,40,40);
      fill(0);
      text(tBeschriftung[i],tastenH/2-8 + i*tastenH,height-tastenH/2+8);     
  }   
}
